# Element.py

"""
A representation of an XML request or response.
"""
class Element:
    def __init__(self, name = '', attributes = {}):
        self.name = name
        self.children = []
        self.attributes = attributes
        self.value = None
    
    def getChildren(self, name = ''):
        if name:
            return [c for c in self.children if c.name == name]
        else:
            return self.children
        
    """
    Intended to be used when merging results from multiple handlers under 
    the root of the response tree, but can be used to merge nodes under
    any tree element.
    """
    def append(self, partialTree):
        if partialTree:
            self.children.append(partialTree)