# Request.py

import os
import sys
import Cookie
from HttpConstants import *

class Request:
    def __init__(self):
        self.headers = os.environ
        self.body = None
        self.sessionId = None
        self.cookies = None
        
        if self.headers.has_key(HTTP_CONTENT_LENGTH):
            length = int(self.headers[HTTP_CONTENT_LENGTH])
            
            if length > 0:
                self.body = sys.stdin.read(length)

        # parse the request cookies
        if self.headers.has_key(HTTP_COOKIE):
            self.cookies = Cookie.SimpleCookie(self.headers[HTTP_COOKIE])
                
        # resolve the session ID
        if self.cookies != None and self.cookies.has_key(SESSION_ID):
            self.sessionId = self.cookies[SESSION_ID].value
            
    def getHost(self):
        host = None
        
        if self.headers.has_key(HTTP_HOST):
            host = self.headers[HTTP_HOST]
            
        return host
        
    def getUserAgent(self):
        ua = None
        
        if self.headers.has_key(HTTP_USER_AGENT):
            ua = self.headers[HTTP_USER_AGENT]
            
        return ua
    
