# RequestParser.py

from Element import Element
from xml.parsers import expat

"""
Parse the XML to create an object representation of the XML request.
"""
class RequestParser:
    def __init__(self):
        self.rootElement = None
        self.stack = []
        
    def start(self, name, attributes):
        element = Element(name, attributes)
        
        if not self.rootElement:
            self.rootElement = element
            self.stack.append(element)
        else:
            self.stack[len(self.stack) - 1].children.append(element)
        
        self.stack.append(element)
            
    def end(self, name):
        self.stack.pop()
        
    def characters(self, cdata):
        self.stack[len(self.stack) - 1].value = cdata
        
    def parse(self, content):
        parser = expat.ParserCreate()
        parser.StartElementHandler = self.start
        parser.EndElementHandler = self.end
        parser.CharacterDataHandler = self.characters
        parserStatus = parser.Parse(content, 1)
        return self.rootElement
    
    