# Response.py

import Cookie
from HttpConstants import *

"""
An HTTP response.
"""
class Response:
    MODE_XML = 'xml'
    MODE_HTML = 'html'
    MODE_PLAIN = 'plain'
    
    def __init__(self, mode = MODE_HTML):
        if mode == self.MODE_XML:
            self.headers = {CONTENT_TYPE:APPLICATION_XML}
        elif mode == self.MODE_HTML:
            self.headers = {CONTENT_TYPE:TEXT_HTML}
        elif mode == self.MODE_PLAIN:
            self.headers = {CONTENT_TYPE:TEXT_PLAIN}
        else:
            self.headers = {}

        self.body = ""
        self.cookies = Cookie.SimpleCookie()

    def output(self):
        out = ""
        
        for key in self.headers.keys():
            # I'm not stripping out duplicate headers
            out += key + ': ' + self.headers[key] + '\n'

        if self.cookies:
            self.cookies.output()
            
        out += '\n\n' + self.body

        return out

    def __str__(self):
        return self.output()
